/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCppXNX                           */
/*      \            Path                                                  */
/*      pbP[W  jsd.ref                                               */
/*      ŏIXV      2006/05/31(Wed)                                       */
/*      o[W      2.00.00                                               */
/*      쌠\      Copyright (C) 2004-2006 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * pXNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.ref.PathNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.ref.Path";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V File Function jsd.ref.File
  var File = jsd.ref.File;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C DIRECTORY_TOKEN String fBNg؂蕶
  Class.DIRECTORY_TOKEN = "/";
  //:C FOLDER_TOKEN String tH_؂蕶
  Class.FOLDER_TOKEN = "\\";
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //------------------------------------------------------------------------------
  Static.getAbsolutePath = function(basePath, targetPath)
   /**
    * ΃pX΃pX擾
    * @explanation basePath(΃pX)ɂtargetPath(΃pX)΃pXƂĎ擾B
    * @param basePath jsd.ref.Path ƂȂ΃pX
    * @param targetPath jsd.ref.Path ΏۂƂȂ鑊΃pX
    * @return jsd.ref.Path Ώۂ̐΃pX
    * @throw ConditionException basePath΃pXłȂ܂targetPath΃pXłȂꍇ
    * @throws ParameterFormatException s
    */
    {
    if(!(basePath instanceof Class))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, basePath, "basePath", "jsd.ref.Path", "FAIL");
      }
    if(!(targetPath instanceof Class))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, targetPath, "targetPath", "jsd.ref.Path", "FAIL");
      }
    if(!basePath.isAbsolute())
      {
      throw new Error("ConditionException", Creator.CompleteName, null, basePath, "basePath͐΃pX", "FAIL");
      }
    if(targetPath.isAbsolute())
      {
      throw new Error("ConditionException", Creator.CompleteName, null, targetPath, "targetPath͑΃pX", "FAIL");
      }
    // fBNg
    var bDirs = basePath.getDirectories();
    var tDirs = targetPath.getDirectories();
    var bIdx = bDirs.length;
    for(var tIdx = 0; tIdx < tDirs.length; tIdx++)
      {
      var dir = tDirs[tIdx];
      if(!dir || (dir == "."))
        {
        // Do nothing.
        }
      else if(dir == "..")
        {
        if(bIdx > 0)
          {
          bDirs[--bIdx] = null;
          }
        }
      else
        {
        bDirs[bIdx++] = dir;
        }
      }
    bDirs.length = bIdx;
    // CX^X
    var token = basePath.token;
    if(!token || ((typeof token) != "string"))
      {
      token = Class.DIRECTORY_TOKEN;
      }
    var file = targetPath.getFile();
    var path = token + bDirs.join(token) + token + (file ? file : "");
    var obj = new Class(path);
    return obj;
    };
  //------------------------------------------------------------------------------
  Static.getRelativePath = function(basePath, targetPath)
   /**
    * ΃pX瑊΃pX擾
    * @explanation basePath(΃pX)ɂtargetPath(΃pX)𑊑΃pXƂĎ擾B
    * @param basePath jsd.ref.Path ƂȂ΃pX
    * @param targetPath jsd.ref.Path ΏۂƂȂ΃pX
    * @return jsd.ref.Path Ώۂ̑΃pX
    * @throw ConditionException basePathytargetPath΃pXłȂꍇ
    * @throws ParameterFormatException s
    */
    {
    if(!(basePath instanceof Class))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, basePath, "basePath", "jsd.ref.Path", "FAIL");
      }
    if(!(targetPath instanceof Class))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, targetPath, "targetPath", "jsd.ref.Path", "FAIL");
      }
    if(!basePath.isAbsolute())
      {
      throw new Error("ConditionException", Creator.CompleteName, null, basePath, "basePath͐΃pX", "FAIL");
      }
    if(!targetPath.isAbsolute())
      {
      throw new Error("ConditionException", Creator.CompleteName, null, targetPath, "targetPath͐΃pX", "FAIL");
      }
    // fBNg
    var bDirs = basePath.getDirectories();
    var tDirs = targetPath.getDirectories();
    var len = Math.min(bDirs.length, tDirs.length);
    for(var idx = 0; idx < len; idx++)
      {
      if(bDirs[idx] != tDirs[idx])
        {
        len = idx;
        break;
        }
      }
    // CX^X
    var token = basePath.token;
    if(!token || ((typeof token) != "string"))
      {
      token = Class.DIRECTORY_TOKEN;
      }
    var path;
    if(len < bDirs.length)
      {
      path = "";
      for(var idx = len; idx < bDirs.length; idx++)
        {
        path += ".." + token;
        }
      }
    else
      {
      path = "." + token;
      }
    path += tDirs.slice(len, tDirs.length).join(token) + token;
    var file = targetPath.getFile();
    if(file)
      {
      path += file;
      }
    var obj = new Class(path);
    return obj;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P token String pX؂蕶
  Proto.token = Class.DIRECTORY_TOKEN;
  
  //------------------------------------------------------------------------------
  Proto.setPath = function(path)
   /**
    * pX(fBNg{t@C)ݒ肷
    * @notice pX̋؂蕶͈璲ׂĎݒ肳B
    * @param path String pX
    * @throws StringFormatException s
    */
    {
    if(!path || ((typeof path) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, path, "path", "NotEmptyString", "FAIL");
      }
    if(path.indexOf(Class.DIRECTORY_TOKEN, 0) >= 0)
      {
      this.token = Class.DIRECTORY_TOKEN;
      }
    else if(path.indexOf(Class.FOLDER_TOKEN, 0) >= 0)
      {
      this.token = Class.FOLDER_TOKEN;
      }
    var token, dName, fName, tPoint;
    if(this.token && ((typeof this.token) == "string"))
      {
      token = this.token;
      }
    else
      {
      token = Class.DIRECTORY_TOKEN;
      }
    if((tPoint = path.lastIndexOf(token, path.length)) >= 0)
      {
      dName = path.substring(0, tPoint);
      fName = path.substring(tPoint + token.length, path.length);
      }
    else
      {
      dName = "";
      fName = path;
      }
    this.setDirectory(dName);
    if(!fName)
      {
      this.setFile(null);
      }
    else
      {
      var file = this.getFile();
      if(file)
        {
        file.setName(fName);
        }
      else
        {
        file = new File(fName);
        this.setFile(file);
        }
      }
    };
  //------------------------------------------------------------------------------
  Proto.getAbsolutePath = function(targetPath)
   /**
    * ΃pX΃pX擾
    * @explanation this(΃pX)ɂtargetPath(΃pX)΃pXƂĎ擾B
    * @param targetPath jsd.ref.Path ΏۂƂȂ鑊΃pX
    * @return jsd.ref.Path Ώۂ̐΃pX
    * @through ConditionException|ParameterFormatException
    */
    {
    return Static.getAbsolutePath(this, targetPath);
    };
  //------------------------------------------------------------------------------
  Proto.getRelativePath = function(targetPath)
   /**
    * ΃pX瑊΃pX擾
    * @explanation this(΃pX)ɂtargetPath(΃pX)𑊑΃pXƂĎ擾B
    * @param targetPath jsd.ref.Path ΏۂƂȂ΃pX
    * @return jsd.ref.Path Ώۂ̑΃pX
    * @through ConditionException|ParameterFormatException
    */
    {
    return Static.getRelativePath(this, targetPath);
    };
  //------------------------------------------------------------------------------
  Proto.toString = function()
   /**
    * pX̕\擾
    * @return String \
    */
    {
    var dir = this.getDirectory();
    var tkn = this.token;
    var fbj = this.getFile();
    var path = (dir ? dir : "") + (tkn ? tkn : "") + (fbj ? fbj.toString() : "");
    return path;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(path)
   /**
    * pXNX
    * @param path [String] pX
    * @return jsd.ref.Path CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v directories Array|null fBNgz
    var directories = null;
    //:v file jsd.ref.File|null t@CIuWFNg
    var file = null;
    
    //------------------------------------------------------------------------------
    function getToken()
     /**
      * pX؂蕶擾
      * @condition this͂̃NX̃CX^XƂĎsB
      * @return String pX؂蕶
      */
      {
      var token = this.token;
      if((typeof token) != "string")
        {
        token = Proto.token;
        }
      if((typeof token) != "string")
        {
        token = "/";
        }
      return token;
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getDirectory = function()
     /**
      * fBNg擾
      * @return String fBNg(Ōɋ؂蕶͕tȂ)
      */
      {
      var dir = directories ? directories.join(getToken.call(this)) : "";
      return dir;
      };
    //------------------------------------------------------------------------------
    this.getDirectories = function()
     /**
      * fBNg̔z擾
      * @return Array fBNg̔z
      */
      {
      var dirs;
      if(!directories || (directories.length <= 0))
        {
        dirs = [];
        }
      else if(!directories[0])
        {
        dirs = directories.slice(1, directories.length);
        }
      else
        {
        dirs = [];
        for(var i = 0; i < directories.length; i++)
          {
          dirs[i] = directories[i];
          }
        }
      return dirs;
      };
    //------------------------------------------------------------------------------
    this.setDirectory = function(directory)
     /**
      * fBNgݒ肷
      * @notice ̃\bhł͋؂蕶̎C͍sȂB
      * @param directory String|null fBNg(Ōɋ؂蕶ĂȂĂ悢)
      * @throw StringFormatException s
      */
      {
      if((directory != null) && ((typeof directory) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, directory, "directory", "String|null", "FAIL");
        }
      if(directory == null)
        {
        directories = null;
        }
      else
        {
        var token = getToken.call(this);
        directories = [];
        if(directory && (directory.charAt(0) == token))
          {
          directories[0] = "";
          }
        var dirs = directory.split(token);
        for(var i = 0; i < dirs.length; i++)
          {
          if(dirs[i])
            {
            directories[directories.length] = dirs[i];
            }
          }
        }
      };
    //------------------------------------------------------------------------------
    this.getFile = function()
     /**
      * t@CIuWFNg擾
      * @return jsd.ref.File|null t@CIuWFNg
      */
      {
      return file;
      };
    //------------------------------------------------------------------------------
    this.setFile = function(fileObj)
     /**
      * t@CIuWFNgݒ肷
      * @param fileObj jsd.ref.File|null t@CIuWFNg
      * @throws ParameterFormatException s
      */
      {
      if((fileObj != null) && !(fileObj instanceof File))
        {
        throw new Error("ParameterFormatException", Creator.CompleteName, null, fileObj, "fileObj", "ParameterFormatException", "FAIL");
        }
      file = fileObj ? fileObj : null;
      };
    //------------------------------------------------------------------------------
    this.isAbsolute = function()
     /**
      * ΃pXǂ擾
      * @notice s\ȏꍇfalseԂB
      * @return Boolean ΃pXǂ
      */
      {
      var isAbs = (directories && (directories.length > 0) && !directories[0]);
      return isAbs;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    if(path && ((typeof path) == "string"))
      {
      this.setPath(path);
      }
    return this;
    }
  
  return Class;
  });
